package gui;

import java.util.Vector;

import javax.swing.CellRendererPane;
import javax.swing.JCheckBox;
import javax.swing.table.AbstractTableModel;

import basicas.Aluno;

public class ModeloTabela extends AbstractTableModel {

	private String[][] nomes;
	private int tipoModelo;
	private String[] columnNames;
	private Object[][] data; 
	private JCheckBox[] check;

	public ModeloTabela(String nome, int tipoModelo, String[][] textos, Vector<Integer> cod_turma){

		this.nomes = textos;
		this.tipoModelo = tipoModelo;
		if(tipoModelo == 1){
			//remover e atualizar
			columnNames = new String[2];
			columnNames[0] = "Nome";

			int i = 0;

			if(nome.equalsIgnoreCase("Selecione o funcionrio a ser removido")
					|| nome.equalsIgnoreCase("Selecione o funcionario a ser atualizado")) {

				columnNames[1] = "Funo";
				int tamanho = nomes.length;
				data =  new Object[tamanho][3];
				if(i < tamanho){
					while(i < tamanho){
						data[i][0] = nomes[i][0];
						data[i][1] = nomes[i][1];
						i++;
					}	
				}

			}else if(nome.equalsIgnoreCase("Selecione o aluno a ser removido")
					|| nome.equalsIgnoreCase("Selecione o aluno a ser atualizado")
					|| nome.equalsIgnoreCase("Selecione o aluno:")
					|| nome.equalsIgnoreCase("Escolha o aluno:")){

				columnNames[1] = "Nome da me";

				int tamanho = nomes.length;
				data =  new Object[tamanho][3];
				if(i < tamanho){
					while(i < tamanho){
						data[i][0] = nomes[i][0];
						data[i][1] = nomes[i][1];
						i++;
					}	
				}
			}else if(nome.equalsIgnoreCase("Selecione a turma a ser removida")
					|| nome.equalsIgnoreCase("Selecione a turma a ser atualizada")){

				columnNames[1] = "Dia/Horrio";

				int tamanho = nomes.length;
				data =  new Object[tamanho][3];
				if(i < tamanho){
					while(i < tamanho){
						data[i][0] = nomes[i][0];
						data[i][1] = nomes[i][1];
						i++;
					}	
				}


			}else if(nome.equalsIgnoreCase("Selecione a despesa a ser removida")
					|| nome.equalsIgnoreCase("Selecione a despesa a ser atualizada")){
				columnNames[1] = "Valor";

				int tamanho = nomes.length;
				data =  new Object[tamanho][3];
				if(i < tamanho){
					while(i < tamanho){
						data[i][0] = nomes[i][0];
						data[i][1] = nomes[i][1];
						i++;
					}	
				}


			}else if(nome.equalsIgnoreCase("Selecione a escola parceira a ser removida")
					|| nome.equalsIgnoreCase("Selecione a escola parceira a ser atualizada" )){
				columnNames[1] = "Telefone";
				int tamanho = nomes.length;
				data =  new Object[tamanho][3];
				if(i < tamanho){
					while(i < tamanho){
						data[i][0] = nomes[i][0];
						data[i][1] = nomes[i][1];
						i++;
					}	
				}
			}else if(nome.equalsIgnoreCase("Selecione o festival a ser removido")){
				columnNames[1] = "Data";
			}else if(nome.equalsIgnoreCase("Selecione a modalidade a ser removida")
					|| nome.equalsIgnoreCase("Selecione a modalidade a ser atualizada")){

				columnNames[1] = "Valor";
				int tamanho = nomes.length;
				data =  new Object[tamanho][3];
				if(i < tamanho){
					while(i < tamanho){
						data[i][0] = nomes[i][0];
						data[i][1] = nomes[i][1];
						i++;
					}	
				}


			}else if(nome.equalsIgnoreCase("Selecione a dana a ser removida")){
				columnNames[1] = "Festival";
			}


		}else if(tipoModelo == 2){
			//escolha turma
			columnNames = new String[4];
			columnNames[0] = "";
			columnNames[1] = "Nome";
			columnNames[2] = "Dia/Horrio";
			columnNames[3] = "Faixa Etria";


			int tamanho = nomes.length;
			data =  new Object[tamanho][4];

		//	data[0][0] = new Boolean(false);
		
			for(int i = 0; i < tamanho; i++){

				data[i][0] = new Boolean(false);
				data[i][1] = nomes[i][0];
				data[i][2] = nomes[i][1];                  
				data[i][3] = nomes[i][2];

			}


			/*			for(int i = 2; i < tamanho; i++){
				data[i][0] = new Boolean(false);

			}*/

			//			for(int i = 2; i < 13; i++){
			//				for(int j = 1; j < 5; j++){
			//					data[i][j] = "";
			//				}
			//			}

		}else if(tipoModelo == 3){
			//escolha bailarinos
			columnNames = new String[3];
			columnNames[0] = "";
			columnNames[1] = "Nome";
			columnNames[2] = "Turma";
			data =  new Object[13][3];

			data[0][0] = new Boolean(false);
			data[0][1] = "oi";
			data[0][2] = "oi";

			data[1][0] = new Boolean(false);
			data[1][1] = "oi";
			data[1][2] = "oi";



			for(int i = 2; i < 13; i++){
				data[i][0] = new Boolean(false);
			}

			for(int i = 2; i < 13; i++){
				for(int j = 1; j < 3; j++){
					data[i][j] = "";
				}
			}
		}else if(tipoModelo == 4){
			//relatorio aluno
			columnNames = new String[9];
			columnNames[0] = "Nome";
			columnNames[1] = "Idade";
			columnNames[2] = "CPF";
			columnNames[3] = "Telefone";
			columnNames[4] = "Endereo";
			columnNames[5] = "Data de Nascimento";
			columnNames[6] = "Escola";
			columnNames[7] = "Nome da Me";
			columnNames[8] = "Nome do Pai";

			int tamanho = nomes.length;
			data =  new Object[tamanho][9];
			int i = 0;
			if(i < tamanho){
				while(i < tamanho){
					data[i][0] = nomes[i][0];
					data[i][1] = nomes[i][1];
					data[i][2] = nomes[i][2];
					data[i][3] = nomes[i][3];
					data[i][4] = nomes[i][4];
					data[i][5] = nomes[i][5];
					data[i][6] = nomes[i][6];
					data[i][7] = nomes[i][7];
					data[i][8] = nomes[i][8];
					i++;
				}	
			}

			//private int diaVencimento;
			//private double mensalidade;

		}else if(tipoModelo == 5){
			//relatorio turma
			columnNames = new String[7];
			columnNames[0] = "Cdigo";
			columnNames[1] = "Nome";
			columnNames[2] = "Idade"; //em idade vai por uma string assim: "12 a 14"
			columnNames[3] = "Horrio"; //"14:00 as 16:00"
			columnNames[4] = "Sala";
			columnNames[5] = "Modalidade";
			columnNames[6] = "Professor";
			int tamanho = nomes.length;
			data =  new Object[tamanho][7];
			int i = 0;
			if(i < tamanho){
				while(i < tamanho){
					data[i][0] = nomes[i][0];
					data[i][1] = nomes[i][1];
					data[i][2] = nomes[i][2];
					data[i][3] = nomes[i][3];
					data[i][4] = nomes[i][4];
					data[i][5] = nomes[i][5];
					data[i][6] = nomes[i][6];
					i++;
				}	
			}
		}else if(tipoModelo == 6){
			//relatorio funcionario
			columnNames = new String[10];
			columnNames[0] = "Nome";
			columnNames[1] = "CPF";
			columnNames[2] = "RG";
			columnNames[3] = "Sexo";
			columnNames[4] = "Data de Nascimento";
			columnNames[5] = "Telefone";
			columnNames[6] = "Endereo";
			columnNames[7] = "Email";
			columnNames[8] = "Funo";
			columnNames[9] = "Salrio (R$)";
			int tamanho = nomes.length;
			data =  new Object[tamanho][10];
			int i = 0;
			if(i < tamanho){
				while(i < tamanho){
					data[i][0] = nomes[i][0];
					data[i][1] = nomes[i][1];
					data[i][2] = nomes[i][2];
					data[i][3] = nomes[i][3];
					data[i][4] = nomes[i][4];
					data[i][5] = nomes[i][5];
					data[i][6] = nomes[i][6];
					data[i][7] = nomes[i][7];
					data[i][8] = nomes[i][8];
					data[i][9] = nomes[i][9];
					i++;
				}	
			}

		}else if(tipoModelo == 7){
			//relatorio modalidade
			columnNames = new String[2];
			columnNames[0] = "Nome";
			columnNames[1] = "Valor (R$)";
			int tamanho = nomes.length;
			data =  new Object[tamanho][2];
			int i = 0;
			if(i < tamanho){
				while(i < tamanho){
					data[i][0] = nomes[i][0];
					data[i][1] = nomes[i][1];
					i++;
				}	
			}
		}else if(tipoModelo == 8){
			//relatorio despesa
			columnNames = new String[5];
			columnNames[0] = "Cdigo";
			columnNames[1] = "Valor (R$)";
			columnNames[2] = "Data de Vencimento";
			columnNames[3] = "Data de Pagamento"; 
			columnNames[4] = "Empresa Beneficiada";
			int tamanho = nomes.length;
			data =  new Object[tamanho][5];
			int i = 0;
			if(i < tamanho){
				while(i < tamanho){
					data[i][0] = nomes[i][0];
					data[i][1] = nomes[i][1];
					data[i][2] = nomes[i][2];
					data[i][3] = nomes[i][3];
					data[i][4] = nomes[i][4];
					i++;
				}	
			}

		}else if(tipoModelo == 9){
			//relatorio escola pareceira
			columnNames = new String[5];
			columnNames[0] = "Cdigo";
			columnNames[1] = "Nome";
			columnNames[2] = "Telefone";
			columnNames[3] = "Responsvel";
			columnNames[4] = "Endereo";
			int tamanho = nomes.length;
			data =  new Object[tamanho][5];
			int i = 0;
			if(i < tamanho){
				while(i < tamanho){
					data[i][0] = nomes[i][0];
					data[i][1] = nomes[i][1];
					data[i][2] = nomes[i][2];
					data[i][3] = nomes[i][3];
					data[i][4] = nomes[i][4];

					i++;
				}	
			}
		}else if(tipoModelo == 10){
			//Atualizar
				
			columnNames = new String[4];
			columnNames[0] = "";
			columnNames[1] = "Nome";
			columnNames[2] = "Dia/Horrio";
			columnNames[3] = "Faixa Etria";


			int tamanho = nomes.length;
			data =  new Object[tamanho][4];


			//data[0][0] = new Boolean(false);
			
			int size = cod_turma.size();
			
			for(int i = 0; i < tamanho; i++){
				
				for(int k = 0; k < size; k++){
					
					if(i == (int)cod_turma.get(k)){
						data[i][0] = new Boolean(true);
						k = size;
					}else{
						data[i][0] = new Boolean(false);

					}
				}
				if(size == 0){
					data[i][0] = new Boolean(false);

				}
				data[i][1] = nomes[i][0];
				data[i][2] = nomes[i][1];                  
				data[i][3] = nomes[i][2];

			}


			/*			for(int i = 2; i < tamanho; i++){
				data[i][0] = new Boolean(false);

			}*/

			//			for(int i = 2; i < 13; i++){
			//				for(int j = 1; j < 5; j++){
			//					data[i][j] = "";
			//				}
			//			}

		}

	}

	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return data.length;
	}

	public String getColumnName(int col) {
		return columnNames[col];
	}

	public Object getValueAt(int row, int col) {
		return data[row][col];
	}

	public void setValueAt(Object value, int row, int col) {
		data[row][col] = value;
		fireTableCellUpdated(row, col);
	}

	public Class getColumnClass(int c) {
		return getValueAt(0, c).getClass();
	}

	public boolean isCellEditable(int row, int col) {
		if(this.tipoModelo == 2 || this.tipoModelo == 3 || this.tipoModelo == 10){
			if(col < 1){
				return true;
			}else{	
				return false;
			}
		}else{
			return false;
		}
	}

	public Object[][] getData() {
		return data;
	}

	public void setData(Object[][] data) {
		this.data = data;
	}



}