package gui;

import java.util.Vector;

import javax.swing.CellRendererPane;
import javax.swing.JCheckBox;
import javax.swing.table.AbstractTableModel;

import basicas.Aluno;

public class TabelaAtualizar extends AbstractTableModel {

	private String[][] nomes;
	private int tipoModelo;
	private String[] columnNames;
	private Object[][] data; /*= {
            {new Boolean(false), "Mary", "Campione",
	             "Snowboarding", new Integer(5)},
	            {new Boolean(true), "Alison", "Huml",
	             "Rowing", new Integer(3)},
	            {new Boolean(false), "Kathy", "Walrath",
	             "Knitting", new Integer(2)},
	            {new Boolean(true), "Sharon", "Zakhour",
	             "Speed reading", new Integer(20)},
	            {new Boolean(false), "Philip", "Milne",
	             "Pool", new Integer(10)},
	        };*/

	public TabelaAtualizar(String nome, int tipoModelo,String[][] alunos){
		this.nomes = alunos;
		this.tipoModelo = tipoModelo;
		if(tipoModelo == 1){
			columnNames = new String[2];
			columnNames[0] = "Nome";
			
			int i = 0;

			if(nome.equalsIgnoreCase("Selecione o funcionrio a ser atualizado")){
				columnNames[1] = "Funo";
				
			}else if(nome.equalsIgnoreCase("Selecione o aluno a ser atualizado")){
				columnNames[1] = "Nome da me";
				int tamanho = nomes.length;
				data =  new Object[tamanho][3];
				if(i < tamanho){
					while(i < tamanho){
						data[i][0] = nomes[i][0];
						data[i][1] = nomes[i][1];
						i++;
					}	
				}
			}else if(nome.equalsIgnoreCase("Selecione a turma a ser atualizada")){
				columnNames[1] = "Dia/Horrio";
			}else if(nome.equalsIgnoreCase("Selecione a despesa a ser atualizada")){
				columnNames[1] = "Valor";
			}else if(nome.equalsIgnoreCase("Selecione a escola parceira a ser atualizada")){
				columnNames[1] = "Telefone";
				int tamanho = nomes.length;
				data =  new Object[tamanho][3];
				if(i < tamanho){
					while(i < tamanho){
						data[i][0] = nomes[i][0];
						data[i][1] = nomes[i][1];
						i++;
					}	
				}
			}else if(nome.equalsIgnoreCase("Selecione o festival a ser atualizada")){
				columnNames[1] = "Data";
			}else if(nome.equalsIgnoreCase("Selecione a modalidade a ser atualizada")){
				columnNames[1] = "Preo";
			}else if(nome.equalsIgnoreCase("Selecione a dana a ser atualizada")){
				columnNames[1] = "Festival";
			}

			//this.inicializarTabela();

		}else if(tipoModelo == 2){
			//String[] columnNames = {"", "Nome", "Horrio", "Dias", "Faixa Etria"};
			columnNames = new String[5];
			columnNames[0] = "";
			columnNames[1] = "Nome";
			columnNames[2] = "Horrio";
			columnNames[3] = "Dias";
			columnNames[4] = "Faixa Etria";

			data =  new Object[13][5];

			data[0][0] = new Boolean(false);
			data[0][1] = "oi";
			data[0][2] = "oi";
			data[0][3] = "oi";
			data[0][4] = "oi";

			data[1][0] = new Boolean(false);
			data[1][1] = "oi";
			data[1][2] = "oi";
			data[1][3] = "oi";
			data[1][4] = "oi";


			for(int i = 2; i < 13; i++){
				data[i][0] = new Boolean(false);
			}

			for(int i = 2; i < 13; i++){
				for(int j = 1; j < 5; j++){
					data[i][j] = "";
				}
			}




			//data[1][0] = new Boolean(true);
			/*data[2][0] = new Boolean(true);
			data[3][0] = new Boolean(true);
			data[4][0] = new Boolean(true);
			data[5][0] = new Boolean(true);
			data[6][0] = new Boolean(true);
			data[7][0] = new Boolean(true);
			data[8][0] = new Boolean(true);
			data[9][0] = new Boolean(true);
			data[10][0] = new Boolean(true);
			data[11][0] = new Boolean(true);
			data[12][0] = new Boolean(true);*/

			//data[0][0] = "oi";
			//data[1][1] = "oi";
			/*data[2][2] = "opi";
			data[3][3] = "io";
			data[4][4] = "oi";
			data[5][5] = "oi";
			data[6][6] = "oi";
			data[7][7] = "oi";
			data[8][8] = "oi";
			data[9][9] = "oi";
			data[10][10] = "oi";
			data[11][11] = "oi";
			data[12][12] = "oi";*/



			/*int i = 0;
			while(i < 13){
				data[i][0] = this.criarCheckBox();
				i++;
			}*/
		}else if(tipoModelo == 3){
			columnNames = new String[3];
			columnNames[0] = "";
			columnNames[1] = "Nome";
			columnNames[2] = "Turma";
			data =  new Object[13][3];

			data[0][0] = new Boolean(false);
			data[0][1] = "oi";
			data[0][2] = "oi";

			data[1][0] = new Boolean(false);
			data[1][1] = "oi";
			data[1][2] = "oi";


			for(int i = 2; i < 13; i++){
				data[i][0] = new Boolean(false);
			}

			for(int i = 2; i < 13; i++){
				for(int j = 1; j < 3; j++){
					data[i][j] = "";
				}
			}
		}

		//this.inicializarTabela();
	}

/*	void inicializarTabela(){
		int i = 0;

		if(i < nomes.size()){
			while(i < nomes.size()){
				data[i][0] = nomes.get(i).getNome();
				data[i][1] = nomes.get(i).getNomeMae();
				i++;
			}	
		}
	}*/

	/*public JCheckBox criarCheckBox(int xPosicao, int yPosicao){
		JCheckBox box = new JCheckBox();
		//this.add(box);
		box.setLayout(null);
		box.setSize(20, 20);
		//box.setLocation(xPosicao, yPosicao);
		return box;
	}*/

	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return data.length;
	}

	public String getColumnName(int col) {
		return columnNames[col];
	}

	public Object getValueAt(int row, int col) {
		return data[row][col];
	}

	public void setValueAt(Object value, int row, int col) {
		data[row][col] = value;
		fireTableCellUpdated(row, col);
	}

	public Class getColumnClass(int c) {
		return getValueAt(0, c).getClass();
	}

	public boolean isCellEditable(int row, int col) {
		if(this.tipoModelo == 2 || this.tipoModelo == 3){
			if(col < 1){
				return true;
			}else{	
				return false;
			}
		}else{
			return false;
		}
	}

}