//ModificacaoAlice
package basicas;

import java.awt.image.BufferedImage;
import java.io.File;
import java.util.Vector;

public class Aluno {

	private String nome;
	private int idade;
	private String codigoAluno;
	private String cpf;
	private String rg;
	private String endereco;
	private char sexo;
	private String nascimento;
	private String alergias;
	private String nomeEscola;
	private String serie;
	private String nomeMae;
	private String profissaoMae;
	private String nomePai;
	private String profissaoPai;
	private boolean autorizacao;
	private int diaVencimento;
	private double mensalidade;
	//
	private byte[] foto;
	private boolean temIrmao;

	private Vector<String> telefones;
	// Chave estrangeira
	private int codigoEscola;
	private String email;
	private String planoSaude;
	private String dataMatricula;

	public Aluno(String nome, String codigo, String cpf, String rg,
			String endereco, char sexo, String nascimento, String alergias,
			String nomeEscola, String serie, String nomeMae,
			String profissaoMae, String nomePai, String profissaoPai,
			boolean sair, int diaVenc, double mensalidade, byte[] foto,
			boolean irmao, Vector<String> telefones, String email,
			String planoSaude, String dataMatricula) {

		this.nome = nome;
		this.codigoAluno = codigo;
		this.cpf = cpf;
		this.rg = rg;
		this.endereco = endereco;
		this.sexo = sexo;
		this.nascimento = nascimento;
		this.alergias = alergias;
		this.nomeEscola = nomeEscola;
		this.serie = serie;
		this.nomeMae = nomeMae;
		this.profissaoMae = profissaoMae;
		this.nomePai = nomePai;
		this.profissaoPai = profissaoPai;
		this.autorizacao = sair;
		this.diaVencimento = diaVenc;
		this.mensalidade = mensalidade;
		this.setFoto(foto);
		this.setTemIrmao(irmao);
		this.telefones = telefones;
		this.email = email;
		this.planoSaude = planoSaude;
		this.dataMatricula = dataMatricula;

	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public String getNome() {
		return nome;
	}

	public void setIdade(int idade) {
		this.idade = idade;
	}

	public int getIdade() {
		return idade;
	}

	public void setCodigoAluno(String codigoAluno) {
		this.codigoAluno = codigoAluno;
	}

	public String getCodigoAluno() {
		return codigoAluno;
	}

	public void setCpf(String cpf) {
		this.cpf = cpf;
	}

	public String getCpf() {
		return cpf;
	}

	public void setRg(String rg) {
		this.rg = rg;
	}

	public String getRg() {
		return rg;
	}

	public void setEndereco(String endereco) {
		this.endereco = endereco;
	}

	public String getEndereco() {
		return endereco;
	}

	public void setSexo(char sexo) {
		this.sexo = sexo;
	}

	public char getSexo() {
		return sexo;
	}

	public void setNascimento(String nascimento) {
		this.nascimento = nascimento;
	}

	public String getNascimento() {
		return nascimento;
	}

	public void setAlergias(String alergias) {
		this.alergias = alergias;
	}

	public String getAlergias() {
		return alergias;
	}

	public void setNomeEscola(String nomeEscola) {
		this.nomeEscola = nomeEscola;
	}

	public String getNomeEscola() {
		return nomeEscola;
	}

	public void setNomeMae(String nomeMae) {
		this.nomeMae = nomeMae;
	}

	public String getNomeMae() {
		return nomeMae;
	}

	public void setProfissaoMae(String profissaoMae) {
		this.profissaoMae = profissaoMae;
	}

	public String getProfissaoMae() {
		return profissaoMae;
	}

	public void setNomePai(String nomePai) {
		this.nomePai = nomePai;
	}

	public String getNomePai() {
		return nomePai;
	}

	public void setProfissaoPai(String profissaoPai) {
		this.profissaoPai = profissaoPai;
	}

	public String getProfissaoPai() {
		return profissaoPai;
	}

	public void setAutorizacao(boolean autorizacao) {
		this.autorizacao = autorizacao;
	}

	public boolean isAutorizacao() {
		return autorizacao;
	}

	public void setDiaVencimento(int diaVencimento) {
		this.diaVencimento = diaVencimento;
	}

	public int getDiaVencimento() {
		return diaVencimento;
	}

	public void setMensalidade(double mensalidade) {
		this.mensalidade = mensalidade;
	}

	public double getMensalidade() {
		return mensalidade;
	}

	public void setCodigoEscola(int codigoEscola) {
		this.codigoEscola = codigoEscola;
	}

	public int getCodigoEscola() {
		return codigoEscola;
	}

	public void setSerie(String serie) {
		this.serie = serie;
	}

	public String getSerie() {
		return serie;
	}

	public void setFoto(byte[] foto) {
		this.foto = foto;
	}

	public byte[] getFoto() {
		return foto;
	}

	public void setTemIrmao(boolean temIrmao) {
		this.temIrmao = temIrmao;
	}

	public boolean isTemIrmao() {
		return temIrmao;
	}

	public void setTelefones(Vector<String> telefones) {
		this.telefones = telefones;
	}

	public Vector<String> getTelefones() {
		return telefones;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getEmail() {
		return email;
	}

	public void setPlanoSaude(String planoSaude) {
		this.planoSaude = planoSaude;
	}

	public String getPlanoSaude() {
		return planoSaude;
	}

	public void setDataMatricula(String dataMatricula) {
		this.dataMatricula = dataMatricula;
	}

	public String getDataMatricula() {
		return dataMatricula;
	}

}
