package gui;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

import basicas.Aluno;

import java.awt.Dimension;
import java.awt.event.MouseListener;
import java.util.Vector;

public class Tabela extends JPanel {

	private static final int SINGLE_SELECTION = 0;
	private JTable tabela;
	private ModeloTabela modelo;

	public Tabela(String nome, int xPosicao, int yPosicao, int xTamanho, int yTamanho, int tipoModelo, String[][] alunos, Vector<Integer> cod_turma) {
		
		
		modelo = new ModeloTabela(nome, tipoModelo, alunos, cod_turma);
		tabela = new JTable(modelo);
		
		if(tipoModelo == 1){
			tabela.getColumnModel().getColumn(0).setPreferredWidth(300); //300
		}else if(tipoModelo == 2){
			tabela.getColumnModel().getColumn(0).setPreferredWidth(40);
			tabela.getColumnModel().getColumn(1).setPreferredWidth(80);
			tabela.getColumnModel().getColumn(2).setPreferredWidth(260);
			tabela.getColumnModel().getColumn(3).setPreferredWidth(90);
		}else if(tipoModelo == 3){
			tabela.getColumnModel().getColumn(0).setPreferredWidth(40);
			tabela.getColumnModel().getColumn(1).setPreferredWidth(300);
			tabela.getColumnModel().getColumn(2).setPreferredWidth(210);
		}else if(tipoModelo == 4){
			tabela.getColumnModel().getColumn(0).setPreferredWidth(150);
			tabela.getColumnModel().getColumn(1).setPreferredWidth(35);
			tabela.getColumnModel().getColumn(2).setPreferredWidth(65);
			tabela.getColumnModel().getColumn(3).setPreferredWidth(45);
			tabela.getColumnModel().getColumn(4).setPreferredWidth(200);
			tabela.getColumnModel().getColumn(5).setPreferredWidth(90);
			tabela.getColumnModel().getColumn(6).setPreferredWidth(100);
			tabela.getColumnModel().getColumn(7).setPreferredWidth(100);
			tabela.getColumnModel().getColumn(8).setPreferredWidth(100);

		}else if(tipoModelo == 5){
			tabela.getColumnModel().getColumn(0).setPreferredWidth(30);
			tabela.getColumnModel().getColumn(1).setPreferredWidth(80);
			tabela.getColumnModel().getColumn(2).setPreferredWidth(60);
			tabela.getColumnModel().getColumn(3).setPreferredWidth(240);
			tabela.getColumnModel().getColumn(4).setPreferredWidth(20);
			tabela.getColumnModel().getColumn(5).setPreferredWidth(70);
			tabela.getColumnModel().getColumn(6).setPreferredWidth(150);
			
		}else if(tipoModelo == 6){
			tabela.getColumnModel().getColumn(0).setPreferredWidth(150);
			tabela.getColumnModel().getColumn(1).setPreferredWidth(75);
			tabela.getColumnModel().getColumn(2).setPreferredWidth(45);
			tabela.getColumnModel().getColumn(3).setPreferredWidth(40);
			tabela.getColumnModel().getColumn(4).setPreferredWidth(120);
			tabela.getColumnModel().getColumn(5).setPreferredWidth(55);
			tabela.getColumnModel().getColumn(6).setPreferredWidth(150);
			tabela.getColumnModel().getColumn(7).setPreferredWidth(150);
			tabela.getColumnModel().getColumn(8).setPreferredWidth(100);
			tabela.getColumnModel().getColumn(9).setPreferredWidth(65);
		}else if(tipoModelo == 7){
			tabela.getColumnModel().getColumn(0).setPreferredWidth(160);
			
		}else if(tipoModelo == 8){
			tabela.getColumnModel().getColumn(0).setPreferredWidth(45);
			tabela.getColumnModel().getColumn(1).setPreferredWidth(50);
			tabela.getColumnModel().getColumn(2).setPreferredWidth(110);
			tabela.getColumnModel().getColumn(3).setPreferredWidth(110);
			tabela.getColumnModel().getColumn(4).setPreferredWidth(220);
			
		}else if(tipoModelo == 9){
			tabela.getColumnModel().getColumn(0).setPreferredWidth(45);
			tabela.getColumnModel().getColumn(1).setPreferredWidth(200);
			tabela.getColumnModel().getColumn(2).setPreferredWidth(55);
			tabela.getColumnModel().getColumn(3).setPreferredWidth(150);
			tabela.getColumnModel().getColumn(4).setPreferredWidth(200);
			
		}else if(tipoModelo == 10){
			tabela.getColumnModel().getColumn(0).setPreferredWidth(40);
			tabela.getColumnModel().getColumn(1).setPreferredWidth(80);
			tabela.getColumnModel().getColumn(2).setPreferredWidth(260);
			tabela.getColumnModel().getColumn(3).setPreferredWidth(90);
		}
		
		tabela.setPreferredScrollableViewportSize(new Dimension(380, 300)); //380, 300
		tabela.setFillsViewportHeight(true);
		tabela.setSelectionMode(SINGLE_SELECTION);
		JScrollPane scrollPane = new JScrollPane(tabela);
		scrollPane.setBounds(xPosicao, yPosicao, xTamanho, yTamanho);
		add(scrollPane);
	}

	/*public Retorno getArquivoSelecionado(){
		int linha = tabela.getSelectedRow();
		int coluna = tabela.getSelectedColumn();
		String nome = (String) modelo.getValueAt(linha, coluna);
		int tamanho = Integer.parseInt((String)modelo.getValueAt(indice, 1));
		return new Retorno(nome, tamanho);
	}*/
	
	public int getArquivoSelecionado(){

	int linha = tabela.getSelectedRow();
	int coluna = tabela.getSelectedColumn();
	
	return linha;
	
	/*String nome = (String) modelo.getValueAt(linha, coluna);
	int tamanho = Integer.parseInt((String)modelo.getValueAt(indice, 1));
	return new Retorno(nome, tamanho);*/
}

	public void setMouseListener(MouseListener m){
		tabela.addMouseListener(m);
	}

	public ModeloTabela getModelo() {
		return modelo;
	}

	public void setModelo(ModeloTabela modelo) {
		this.modelo = modelo;
	}

	
}
