package negocio;

import java.util.Vector;

import repositorios.RepositorioModalidade;
import Excecao.ModalidadeExistenteException;
import basicas.Aluno;
import basicas.Modalidade;

public class NegocioModalidade {
	
		private RepositorioModalidade repModalidade;

		public NegocioModalidade() {
			
			repModalidade = new RepositorioModalidade();
		}

		public void inserirModalidade(Modalidade mod) throws ModalidadeExistenteException {

			if (!repModalidade.existeModalidade(mod.getNome())) {
				repModalidade.inserirModalidade(mod);
			
			} else {
				throw new ModalidadeExistenteException();
			}
		}
		
		public Vector<Modalidade> gerarRelatorioModalidade() {
			return repModalidade.gerarRelatorioModalidade();
		}

		public void removerModalidade(String nome) {
			repModalidade.removerModalidade(nome);
		}

		public void atualizarModalidade(Modalidade mod) {
			repModalidade.atualizarModalidade(mod.getNome(), mod);
		}

		public Vector<Modalidade> consultarModalidadePorNome(String nome) {
			
			Vector<Modalidade> retorno = new Vector<Modalidade>();
			retorno.add(repModalidade.consultarModalidadePorNome(nome));
			
			return retorno;
		}
	


}
